﻿Imports System.Web.UI.WebControls
Imports Infragistics.Web.UI.GridControls


Public Class WebForm1
    Inherits System.Web.UI.Page


#Region " Variables "
    Dim objDS As New Data.DataSet
#End Region

#Region " Procedures "

    Function fillData() As DataSet
        objDS = New Data.DataSet
        '*************************************************
        'Band 1
        '*************************************************
        objDS.Tables.Add("Niv1")
        objDS.Tables("Niv1").Columns.Add("id", GetType(Integer))
        objDS.Tables("Niv1").Columns.Add("code", GetType(String))
        objDS.Tables("Niv1").Columns.Add("nom", GetType(String))
        objDS.Tables("Niv1").Columns.Add("HasHours", GetType(Integer))

        objDS.Tables("Niv1").Rows.Add(New Object() {1, "101", "Parent 1", 1})
        objDS.Tables("Niv1").Rows.Add(New Object() {2, "102", "Parent 2", 0})
        objDS.Tables("Niv1").Rows.Add(New Object() {3, "103", "Parent 3", 0})
        objDS.Tables("Niv1").Rows.Add(New Object() {4, "104", "Parent 4", 0})
        objDS.Tables("Niv1").Rows.Add(New Object() {5, "105", "Parent 5", 0})
        objDS.Tables("Niv1").Rows.Add(New Object() {6, "106", "Parent 6", 0})
        objDS.Tables("Niv1").Rows.Add(New Object() {7, "107", "Parent 7", 0})
        objDS.Tables("Niv1").Rows.Add(New Object() {8, "108", "Parent 8", 0})
        objDS.Tables("Niv1").Rows.Add(New Object() {9, "109", "Parent 9", 1})
        objDS.Tables("Niv1").Rows.Add(New Object() {10, "110", "Parent 10", 0})

        Dim pkeyNiv1(0) As DataColumn
        pkeyNiv1(0) = objDS.Tables("Niv1").Columns("id")
        objDS.Tables("Niv1").PrimaryKey = pkeyNiv1

        '*************************************************
        'Band 2
        '*************************************************
        objDS.Tables.Add("Niv2")
        objDS.Tables("Niv2").Columns.Add("id", GetType(Integer))
        objDS.Tables("Niv2").Columns.Add("ref_WBS_Niv1_ID", GetType(Integer))
        objDS.Tables("Niv2").Columns.Add("code", GetType(String))
        objDS.Tables("Niv2").Columns.Add("nom", GetType(String))
        objDS.Tables("Niv2").Columns.Add("HasHours", GetType(Integer))

        Dim cptNiv2Id As Integer = 0

        For ParentID As Integer = 1 To 10
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "101", "Child 1", 1})
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "102", "Child 2", 0})
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "103", "Child 3", 0})
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "104", "Child 4", 0})
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "105", "Child 5", 0})
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "106", "Child 6", 0})
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "107", "Child 7, 0"})
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "108", "Child 8", 0})
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "109", "Child 9", 1})
            cptNiv2Id += 1
            objDS.Tables("Niv2").Rows.Add(New Object() {cptNiv2Id, ParentID, "110", "Child 10", 0})
            cptNiv2Id += 1
        Next

        Dim pkeyNiv2(0) As DataColumn
        pkeyNiv2(0) = objDS.Tables("Niv2").Columns("id")
        objDS.Tables("Niv2").PrimaryKey = pkeyNiv2

        objDS.Relations.Add("Niv1_Niv2", objDS.Tables("Niv1").Columns("id"), objDS.Tables("Niv2").Columns("ref_WBS_Niv1_ID"))

        Session("Data") = objDS

        Return objDS
    End Function

    Sub bindGrid()
        If Session("Data") IsNot Nothing Then
            whdg.DataSource = TryCast(Session("Data"), DataSet)
        Else
            whdg.DataSource = Nothing
            whdg.GridView.ClearDataSource()
            whdg.DataSource = fillData()
        End If

        whdg.GridView.DataBind()
    End Sub

#End Region

#Region " Evenements "


    'Protected Overrides Sub OnInit(e As EventArgs)
    '    MyBase.OnInit(e)

    '    AddHandler whdg.GridView.Bands("Niv2").RowAdding, AddressOf whdg_RowAdding
    '    AddHandler whdg.GridView.Bands("Niv2").RowUpdating, AddressOf whdg_RowUpdating
    '    AddHandler whdg.GridView.Bands("Niv2").RowsDeleting, AddressOf whdg_RowsDeleting
    'End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If (Not IsPostBack) Then
            If Session("Data") IsNot Nothing Then
                Session.Remove("Data")
            End If
        End If

        bindGrid()

    End Sub


#End Region


End Class